﻿$(document).ready(function () {
    //debugger;
    var AuthTokenKey = 'AuthToken';
    var userName = 'admin';
    var password = 'admin';

    var showElement = function (id) {
        if (!id) return;
        ($('#' + id)).css('display', 'block');
    };

    var hideElement = function (id) {
        if (!id) return;
        ($('#' + id)).css('display', 'none');
    };

    var designerId = 'designer-id';
    var fileViewId = 'file-view-id';
    var viewerId = 'report-viewer-id';

    var showFileView = function () {
        hideElement(designerId);
        hideElement(viewerId);
        showElement(fileViewId);
    };

    var showViewer = function () {
        hideElement(designerId);
        hideElement(fileViewId);
        showElement(viewerId);
    };

    var showDesigner = function () {
        hideElement(fileViewId);
        hideElement(viewerId);

        showElement(designerId);
        designer.focus();
    };

    var makeOptions = function (baseOptions, additionalOptions) {
        return $.extend({}, baseOptions || {}, additionalOptions || {});
    };

    function renderDesigner() {
        //debugger;
        designer.renderApplication(designerId, {

            serverApi: baseServerApi,

            /* File View */
            openFileView: function (options) {
                showFileView();

                var fileViewOptions = makeOptions(options, {
                    serverApi: baseServerApi,

                    createReport: designer.api.createReport,
                    openReport: designer.api.openReport,
                    saveReport: designer.api.saveReport,

                    onClose: function () {
                        showDesigner();
                    }
                });

                fileview.renderFileView(fileViewId, fileViewOptions);
            },

            /* Report Viewer */
            openViewer: function (options) {
                //debugger;
                showViewer();

                var viewerOptions = makeOptions(options, {
                    serviceUri: 'http://10.64.1.76:8080/',
                    onClose: function () {
                        showDesigner();
                    }
                });
                viewer.renderViewer(viewerId, viewerOptions);
            }
        });
    }

    function onSuccessfulLogin(response) {        
        var token = response && response.Token;
        // Set the AuthToken cookie
        Cookies.set(AuthTokenKey, token, { path: 'http://10.64.1.76:8080/api' });
        renderDesigner();
    }

    function onError(ex) { /* Process error here... */ }

    function performLogin() {        
        baseServerApi.login(userName, password)
            .done(onSuccessfulLogin)
            .fail(onError);
    }

    function onSuccessfulCheckAuthToken(response) {
        var isAuthTokenValid = response && response.Valid || false;
        if (isAuthTokenValid) renderDesigner();
        else performLogin();
    }

    // Get the AuthToken cookie
    var cookieAuthToken = Cookies.get(AuthTokenKey);
    if (cookieAuthToken) {
        baseServerApi.checkAuthToken(cookieAuthToken)
            .done(onSuccessfulCheckAuthToken)
            .fail(onError);
    }
    else performLogin();
});
